﻿
var vDataSrc  = 'RS_datasource';
var vFieldUri = 'RS_field';
var vAllowNew = 'RS_allow_new';
var vAllowSel = 'RS_allow_select';
var vAllowDel = 'RS_allow_del';
var vString = 'http://www.w3.org/2001/XMLSchema#string'
function RSTreeview()
{
    this.rowCount = 10;
    this.treeBox = {};
    this.datasrc = {};
    this.path =null;
    this.isHierarchical = false;
    this.isToggling = false;
    this.CanUpdate = null;
    this.CanDelete = null;
}

RSTreeview.prototype = {
    allowNew:function()
    {
        if(this.getTreeattri(vAllowNew) == 'true') 
            return true;
        else
            return false;
    },
    allowDel:function()
    {
        if(this.getTreeattri(vAllowDel) == 'true') 
            return true;
        else
            return false;
    },
    
    initHierarchicalData:function()
    {
        if (arguments.length == 0)
        {
            this.isHierarchical = true;
        }else
        {
            if (arguments[0] == 'true' || arguments[0] == true)
            {
                this.isHierarchical = true;
            }else
            {
                this.isHierarchical = false;
            }
        }
       // alert('initHierarchicalData');
    },
    
    setTree:function(treeBox)     
    {
        // 保存TreeBox
        if(treeBox == null) {
            delete this;
            return;
        }
        this.treeBox = treeBox;
//        var treebody = this.treeBox.treeBody;
//        var treebp = treebody.parentNode; 
//        var isLayer = treebp.getAttribute("RS_Is_Layer");
        
        //得到数据源路径
        this.path = this.getTreeattri(vDataSrc);   
        
        // 从文档中读取数据源
        //this.datasrc = document.RSDataSource;

        //初试化行数
        this.rowCount = document.RSDataSource.GetRowCount(this.path);
        
        // 通知tree，行数变更
        this.treeBox.rowCountChanged (0, this.rowCount);

        // 判断tree是否允许新增
        if(this.allowNew())
        {   //如果允许，增加一空行
            this.treeBox.rowCountChanged (this.rowCount,1);
            this.rowCount += 1;
        }
//        if(isLayer=="true") {
//            document.RSDataSource.InitHierarcalData("Open","");
//        }
    },
    getCellText:function(idx, column) 
    { 
        try
        { 
            //因为TREE在的行好是从0开始的，所以空行的实际序号应该是this.rowCount-1
            var r = document.RSDataSource.GetRowCount(this.path);
            if(  r <= idx && !this.allowNew())
            {
                return null;
            }
            if( r == idx && this.allowNew() )
            {
                return null;
            }
            else
            {
                if(document.RSDataSource == null) return "";
                
                var strURI = this.getCloattri(vFieldUri,column);
                
                if(strURI=="#")return idx+1;
                if (strURI != null)
                {
                    if (strURI.length > 0)
                    {
                        //return null;
                        var val = document.RSDataSource.RSFGetFieldValue(this.path,strURI,idx );
                        //GetSubFix(idx, column)函数用来产生当前idx、column的后缀，
                        //在js脚本文件中tree.orientalView.GetSubFix = 自定义函数名，
                        //此处如果定义了GetSubFix函数，则生成后缀字符串加到val后面。                         
                        if(this.GetSubFix != null) 
                        {
                            var sub = this.GetSubFix(idx, column);
                            val = val+sub;
                        }                        
                        return val;
                    }else return null;
                }else return null;
            }
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\getCellText()\n'+e);
        }
    },
    getCellValue:function(idx, column) 
    {
        try
        {
            var val = this.getCellText(idx, column);
            var t = this.getCloattri("type",column);
            if(t != "checkbox")
                return val;
            else
            {
                //判断字段类型是否为字符型
                var u = this.getCloattri(vFieldUri,column);
                if(val =="Y" || val =='y' || val == 1)   return true;
                else return false;
            }
            
        }catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\getCellValue()\n'+e);
        }
    },
    setCellText:function(idx,column,value)
    {
        try
        {
            //GetSubFix(idx, column)函数用来产生当前idx、column的后缀，
            //在js脚本文件中tree.orientalView.GetSubFix = 自定义函数名，
            //此处如果定义了GetSubFix函数，则判断如果value包括GetSubFix函数生成的后缀字符串，则去掉后缀；如果没有，则什么都不处理。        
            if(this.GetSubFix != null)
            {
                //去掉value后面的后缀
                var sub = this.GetSubFix(idx,column);
                if(sub == value.substr(value.length-sub.length,sub.length))
                    value = value.substr(0,value.length-sub.length);
                
            }        
            if(this.CanUpdate != null)
            {
                if(this.CanUpdate(idx,column,value) != true)
                {
                    return;
                }
                
            }        
            var prevalue = null;//前值
            //如果是最后一行，则先调用addNewCell方法，再更新  
            var strURI = this.getCloattri(vFieldUri,column);//RS_field是clo的一自定义属性。保存字段的URI
            if(idx == this.rowCount-1 && this.allowNew() )
            {
                var Error = this.dataValidityCheck(strURI,this.path,value);
                if(Error.length>0)
                {
                     RSAlert(Error);
                     return;
                }
                else
                {
                    this.addNewCell();
                    document.RSDataSource.RSFUpdate(strURI,value,this.path);
                }
            }
            else
            {
                //document.RSDataSource.RSFMoveTo(idx,this.path);
                var bookmark = document.RSDataSource.IndexToBookMark(this.path,idx,1);
                if (strURI != null)
                {
                    if (strURI.length > 0)
                    {
                        var Error = this.dataValidityCheck(strURI,this.path,value);
                        if(Error.length>0)
                        {
                             RSAlert(Error);
                             return;
                        }
                        else
                        {
                            //document.RSDataSource.RSFUpdate(strURI,value,this.path);
                            prevalue = document.RSDataSource.RSFGetFieldValue(this.path,strURI,idx);
                            document.RSDataSource.RSFUpdateBookMark(strURI,value,this.path,bookmark,1);
                        }
                    }
                }
            }
            //发AfterEditing消息
            var ea = document.createEvent("MouseEvent"); 
            ea.screenXArg = column.index;
            ea.screenYArg = idx;
            ea.column = column;
            ea.initMouseEvent("AfterEditing", true, false, window,
                                  0,ea.screenXArg,ea.screenYArg,
                                  0 ,0,false, 
                                  false,false,
                                  false,0, null);
            ea.prevalue = prevalue;
            ea.curvalue = value;
            ea.column   = column;
            var treebody = this.treeBox.treeBody;
            var treebp = treebody.parentNode; 
            treebp.dispatchEvent(ea); 
            //------------------
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\setCellText()\n'+e);
        }
    },
    setCellValue:function(idx,column,value)
    {
        try
        {
            var t = this.getCloattri("type",column);
            if(t != "checkbox")
                return this.setCellText(idx,column,value);
            else
            {
                //this.selection.select(idx);
                //this.selection.currentColumn = column;
                //判断字段类型是否为字符型
                var u = this.getCloattri(vFieldUri,column);
                var ft = document.RSDataSource.RSFGetFieldType(u);
                if(ft ==vString && value=='true' )
                   this.setCellText(idx,column,'Y');
                else if(ft ==vString) 
                    this.setCellText(idx,column,'N');
                else if(value=='true') 
                    this.setCellText(idx,column,'1');
                else 
                    this.setCellText(idx,column,'0');
            }
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\setCellValue()\n'+e);
        }
    },
   delRow:function(idx)
    {
        try
        {   
            if(this.allowDel())
            {   //if(RSConfirm('真要删除选种的行吗？','系统提示！','是','否')) 
                //{
                    if(this.allowNew() && idx == this.rowCount-1)
                    {
                        alert('不可以删除空行！');//不可以删除空行！
                    }
                    else
                    {                 
                        if (this.CanDelete != null)
                        {
                            if (this.CanDelete())
                            {
                                document.RSDataSource.RSFMoveTo(idx,this.path);
                                document.RSDataSource.RSFDelete(this.path);
                                var deleted = document.createEvent("MouseEvent"); 
                                deleted.index  = idx;
                                deleted.initMouseEvent("RSVDeleted", true, false, window,
                                                      0,0,0,
                                                      0 ,0,false, 
                                                      false,false,
                                                      false,0, null);
                                var treebody = this.treeBox.treeBody;
                                var tree = treebody.parentNode; 
                                tree.dispatchEvent(deleted); 
                                
                            }
                        }else
                        {
                            document.RSDataSource.RSFMoveTo(idx,this.path);
                            document.RSDataSource.RSFDelete(this.path);
                            var deleted = document.createEvent("MouseEvent"); 
                            deleted.index  = idx;
                            deleted.initMouseEvent("RSVDeleted", true, false, window,
                                                  0,0,0,
                                                  0 ,0,false, 
                                                  false,false,
                                                  false,0, null);
                            var treebody = this.treeBox.treeBody;
                            var tree = treebody.parentNode; 
                            tree.dispatchEvent(deleted);
                        }
                        
                    }
                //}                               
            }         
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\ndelRow()\n'+e);
        }
    },
    addNewCell:function()
    {
        try
        {
            //插入一空行
            document.RSDataSource.RSFAddnew(this.path);    
            //发AddNew消息
            var ea = document.createEvent("MouseEvent"); 
           
            ea.initMouseEvent("AddNew", true, false, window,
                                  0,0,0,
                                  0 ,0,false, 
                                  false,false,
                                  false,0, null);
            var treebody = this.treeBox.treeBody;
            var treebp = treebody.parentNode; 
            treebp.dispatchEvent(ea); 
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\addNewCell()\n'+e);
        }
    },
    isEditable:function(idx,column)
    {
        try
        {
            var strClofix = this.getCloattri("editable",column);
            if(strClofix=='true' || strClofix==true)
                return true;
            else
                return false;
        }
        catch(e)
        {
           alert('运行出错！\n'+'TreeView.js\isEditable()\n'+e);
        }
    },
    isSelectable:function(idx,column)
    {
        try
        {
            var strClofix = this.getCloattri(vAllowSel,column);
            if(strClofix=='true' || strClofix==true)
                return true;
            else
                return false;
        }
        catch(e)
        {
             alert('运行出错！\n'+'TreeView.js\isSelectable()\n'+e);
        }
    },
    getCloattri:function(attribute,column)
    {
        try
        {
            if(column == null) return null;
            var boxElement = column.element;
            var strAtrribute = boxElement.getAttribute(attribute);
            return strAtrribute;
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\getCloattri()\n'+e);
        }
    },
    getTreeattri:function(attriname)
    {
        try
        {
            if(!this.treeBox) return null;
            var treebody = this.treeBox.treeBody;
            var treebp = treebody.parentNode; 
            var attrivalue = treebp.getAttribute(attriname);
            return  attrivalue;
         }
         catch(e)
         {
            alert('运行出错！\n'+'TreeView.js\getTreeattri()\n'+e);
         }   
    },
    getRowProperties:function(index,properties)
    {
        
    },
    getCellProperties:function(row,col,properties)
    {
        try
        {
            if ((row % 2) == 0)
            {
                var aserv=Components.classes["@mozilla.org/atom-service;1"].
                          getService(Components.interfaces.nsIAtomService);
                properties.AppendElement(aserv.getAtom("cellBackGround"));
            }
            
            var val = this.getCellText(row, col);//得到该单元的值
            var t = this.getCloattri("type",col);//得到该单元的类型
            if(t == "checkbox")//如果是checkbox类型的
            {
                var aserv=Components.classes["@mozilla.org/atom-service;1"].
                          getService(Components.interfaces.nsIAtomService);
                if (val == 'N' || val == 'n')
                    properties.AppendElement(aserv.getAtom("cbfalse"));
            }
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\getCellProperties()\n'+e);
        }
    },
    getColumnProperties:function(col,properties)
    {
    
    },
     isContainer:function(index)
     {  
        try
        {
            if(!this.isHierarchical) return false;
            var isCon = document.RSDataSource.IsContainer(index,this.path);
            return isCon;
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\nisContainer()\n'+e);
        }
     },
     isContainerOpen:function(index)
     {
        try
        {
            if(!this.isHierarchical) return false;
            var isOpen = document.RSDataSource.IsConOpen(index,this.path);
            return isOpen;
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\nisContainerOpen\n'+e);
        }
        
     },
     isContainerEmpty:function(index)
     {
        // todo
        return false;
     },
     isSeparator:function( index)
     {
        return false;
     },
     isSorted:function()
     {
        return false;
     },
     canDrop:function(index,orientation)
     {
        return false;
     },
     drop:function( row,orientation)
     {
     
     },
     getParentIndex:function(rowIndex)
     {
     
        try
        {   
            if(!this.isHierarchical) return -1;
            var index = document.RSDataSource.GetParentIndex(rowIndex,this.path);
            return index;
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\getParentIndex\n'+e);
        }
     },
     hasNextSibling:function(idx,after)
     {
        try
        {
            var thisLevel = this.getLevel(idx);
            for (var t = after + 1; t < this.rowCount; t++) {
              var nextLevel = this.getLevel(t)
              if (nextLevel == thisLevel) return true;
              else if (nextLevel < thisLevel) {
                  return false;
              }
            }
            return false;

        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\hasNextSibling\n'+e);
        }
     }, 
     getLevel:function(index)
     {
        try
        {
            if(!this.isHierarchical) return 0;
            var sequri = document.RSDataSource.GetConuriFrompath(this.path,rdfs);
            var str = sequri;
            str += '.1';
            //得到schemaURI 
            var schemauri = document.RSDataSource.SplitstrBytag(str);
            schemauri += '/Level';
            var levevalue = parseInt(document.RSDataSource.RSFGetFieldValue(this.path,schemauri,index),10)-1; 
            return levevalue;
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\getLevel\n'+e);
        }
     },
     getImageSrc:function(row,col)
     {
        
     },
     getProgressMode:function(row,col)
     {
        return PROGRESS_NONE;
     },
     toggleOpenState:function(index)
     {
        try
        {
            //调用RDFDB接口
            if(!this.isHierarchical) return ;
            this.isToggling = true;

            document.RSDataSource.TaggleOpenState(index,this.path);
            this.isToggling = false;
        }
        catch(e)
        {
            alert('运行出错！\n'+'TreeView.js\toggleOpenState\n'+e);
        }
     },
     cycleHeader:function(col)
     {
        
     },
     selectionChanged:function()
     {
     
     },
     cycleCell:function(row,col)
     {
        
     },
     performAction:function(action)
     {
     
     },
     performActionOnRow:function(action,row)
     {
     
     },
     performActionOnCell:function(action,row,col)
     {
     
     },
     dataValidityCheck:function(fieldURI,path,checkValue)
     {
        try{
            var strError = '';
            var strString = 'http://www.w3.org/2001/XMLSchema#string';
            var strMaxlen = 'http://www.w3.org/2001/XMLSchema#maxLength';
            var strInt = 'http://www.w3.org/2001/XMLSchema#int';
            var strFloat = 'http://www.w3.org/2001/XMLSchema#float';
            var strLong = 'http://www.w3.org/2001/XMLSchema#long';
            var strShort = 'http://www.w3.org/2001/XMLSchema#short';
            var strByte = 'http://www.w3.org/2001/XMLSchema#byte';
            var strSchema = 'http://realso.cn/sqlhouse/Detailschema';
            var strNulAble = 'http://realso.cn/rdf#NullAble';
            var strIdenty = 'http://realso.cn/rdf#IsIdentity';
      
            var strType =  document.RSDataSource.RSFGetFieldType(fieldURI);
            var strFieldName = GetDisplayName(fieldURI);
            
            if(strType == strInt || strType == strLong || strType == strShort || strType == strLong)
            {
                var isInt = window.IsNumeric(checkValue);
                if(!isInt)
                    strError += strFieldName + '：不是整数\n';
            }
            else if(strType == strFloat)
            {
                var isFloat = window.IsFloat(checkValue);
                if(!isFloat)
                    strError += strFieldName + '：不是小数\n';
            }
            if(strType == strString)
            {
                var strRange = fieldURI + '.range';
                var lenValue = document.RSDataSource.GetFieldInfor(strRange,strMaxlen);
                if(checkValue.length > parseInt(lenValue))
                    strError += strFieldName + '：长度超出了范围\n';
            }
            
            var nullValue = document.RSDataSource.GetFieldInfor(fieldURI,strNulAble);
          
            var identyValue = document.RSDataSource.GetFieldInfor(fieldURI,strIdenty);
      
            if(checkValue.length == 0 && nullValue == 'false' && identyValue == 'false' && strType != strSchema)
            {
                strError += strFieldName + '：不可以为空\n';
            }
            
            return strError;
        }catch(e){
           alert('运行出错！\n'+'TreeView.js\dataValidityCheck\n'+e);
        }
     }
};
function ttt(){
    try{
    alert("ok");
    }
    catch(e){alert(e);}
}