﻿// ============================================================================
//
// = 目录
//       chrome/realso
//
// = 文件名
//      workspace.js
//
// = 描述
//      IDE基本逻辑处理。
//      
// = 作者
//      干劲 javajin@hotmail.com
//      邓东东 dongdongdeng@hotmail.com
//      袁立山 yl_shan@hotmail.com
//
// == 历史
//      0315：代码规范化。Alpha 1.0版本形成
//
// == 待处理
//      
// ============================================================================

///////////////////////////////////////////////////////////////////////////////////
// Workspace Object
var g_w;
///////////////////////////////////////////////////////////////////
RSWViewShowHide_flag=1;
RSWViewRelatedInfo_flag=0;

function RSWNodeNew(){
/*-----------------------------------------------------
 功能：在导航树中新建一节点（文件或文件夹）
-----------------------------------------------------*/
    try
    {
        var tree = document.getElementById("RSWNTree");         
        
        //取的XUL中与树绑定的数据源。所有具有datasources属性的xul元素都有database属性，指向它的sIRDFDataSource对象。
        var tds = tree.database.GetDataSources();
        
        var ds = tds.getNext();

        //取的当前被选中序号
	    var c = tree.currentIndex;
	    
	    if(c<0) 
	    {
	        RSAlertLocal("ChoiceFCO");

    	    return;
	    }
	    
	    var rs = tree.builderView.getResourceAtIndex(c);    //取得当前被选中的resource

	    var id = rs.Value;
        
        //打开一对话框
	    var retVals = { type: null, name: null ,ok: null,path: null,id:null};  

	    var strbundle=document.getElementById("strings");
	    
        var NewObject=strbundle.getString("NewObject");
        
	    wnd = window.openDialog("NodeNew.xul",NewObject,"modal=yes,dependent:yes",retVals);
	    
	    // 如果是新建模式
	    if(retVals.ok == true && !retVals.id)
	    {   
	        //根据retVals.type的值创建一节点
	        node = g_w.CreateNode(retVals.type);
	        
            //给节点的成员变量赋值	        
	        node.Name=retVals.name;
	        
	        node.Path=retVals.path;
	        
	        //根据ID取的workspacenode对象
	        var parent = g_w.AllNodes.getValue(id);
	        
	        //把创建的节点插入到父节点的子节点中
	        parent.AppendChild(node);
	        
	        //把新添加的节点加入到RDF数据源中
	        node.AddToRDF(ds);

            //取得新添加节点的RESOURCE
            var rsc = rdfs.GetResource(node.ID);
	        
            var cont = conunit.MakeSeq(ds, rs);
            
            cont.AppendElement(rsc);
            
            //刷新内存中的RDF树	        
	        tree.builder.rebuild();
	        
	    }
	    else if(retVals.ok == true && retVals.id.length>0)
	    {
	        //根据ID取的workspacenode对象
            var node = g_w.AllNodes.getValue(retVals.id);
            
            //给节点的成员变量赋值
	        node.Name=retVals.name;
            
            //给节点的成员变量赋值
	        node.Path=retVals.path;
	        
	        // 保存节点信息到数据库
	        node.Save();
	        
	        //由修改的predicat生成一RDFRESOURCE对象
	        var prd = rdfs.GetResource("http://realso.cn/rdf/workspace/node#Name");
	        
	        //由修改后的名字生成一RDFNode对象
	        var tar = rdsf.GetLiteral(retVals.name);
	        
            //取的数据源的nsIRDFDataSource接口
	        ds = ds.QueryInterface(CI.nsIRDFDataSource);
	        
	        //由resource和predicate取得修改前名字生成的RDFNode对象
	        var oldTars = ds.GetTarget(rs,prd,true);
	        
	        //在内存中的数据源修改节点名
            ds.Change(rs,prd,oldTars,tar);
            
            //刷新内存中的RDF树
	        tree.builder.rebuild();
	    }
	}
	catch(e)
	{
	    alert(e);
	    return;
	}
}
function RSWNodeNewOK()
{   
/*--------------------------------------------------
    功能：响应对话框确定按扭，给对话框传出的变量赋值
--------------------------------------------------*/
    try
    {
        //对话框中OK键设置为TRUE
        window.arguments[0].ok=true;
        
	    //取的对话框中选中新建类型的RSID的值
    	window.arguments[0].type=document.getElementById("type").selectedItem.attributes.getNamedItem("RSID").value;

	    //取的对话框中变量NAME的值，是用户输入的文件名
	    window.arguments[0].name=document.getElementById("name").value;

	    //取的对话框中变量Path的值，是用户输入的相对路径
	    window.arguments[0].path=document.getElementById("path").value;
	    
	    if(window.arguments[0].type=="3")            //如果为xul文件
	    {
	       if(document.getElementById("name").value.lastIndexOf (".xul")!=(document.getElementById("name").value.length-4)||window.arguments[0].path=="")
	       {
	         
	         if(document.getElementById("name").value.lastIndexOf (".xul")!=(document.getElementById("name").value.length-4)&&window.arguments[0].path=="")
	         {
	            RSAlertLocal("AddPP");
	         }
	         else if(document.getElementById("name").value.lastIndexOf (".xul")!=(document.getElementById("name").value.length-4))
	         {
	            RSAlertLocal("AddP");
	         }
	         else if(window.arguments[0].path=="")
	         {
	            RSAlertLocal("AddFP");
	         }
	         window.arguments[0].ok=false;          //把对话框的OK属性设置为FALSE
	         
	       }
	       else
	       {
	         window.close();
	       }
	    }
	    else
	    {
	      window.close();
	    }
	    
    }
    catch(e)
    {
        alert(e);
    }
	
}
function RSWNodeNewInit()
{   
/*--------------------------------------------------
    功能：新建节点对话框初始化
--------------------------------------------------*/
    try
    {
        // 窗口居中
        window.moveTo ((screen.width-document.getElementById("0").width )/2 ,(screen.height-document.getElementById("0").height )/2);
        
        document.getElementById('name').value = window.arguments[0].name;
        
        document.getElementById('path').value = window.arguments[0].path;
        
        document.getElementById('id').value = window.arguments[0].id;
        
        if(window.arguments[0].type<10)
            document.getElementById('type').selectedIndex=window.arguments[0].type;
        
        else if(window.arguments[0].type==110)
            document.getElementById('type').selectedIndex=10;
        
        else if(window.arguments[0].type==111)
            document.getElementById('type').selectedIndex=11;
	    
	    return true;
    }
    catch(e)
    {
        alert(e);
    }
	
}
function RSWNodeNewCancel()
{
/*----------------------------------------
    功能：响应对话框‘取消’按扭的消息函数
----------------------------------------*/
    try
    {
	    window.arguments[0].ok=false;          //把对话框的OK属性设置为FALSE
	    window.close();
	}
	catch(e)
	{
	    alert(e);
	}
}

function RSWNodeTreeSel()
{
	return true;
}

function RSWNodeRenameOK()
{
/*---------------------------------------------------
    功能：响应‘改名’对话框按扭的‘确定’按扭
---------------------------------------------------*/
    try
    {
        window.arguments[0].ok=true;            //把OK设置为TRUE
	    window.arguments[0].name=document.getElementById("rename").value;   //取得对话框中用户输入的新名值
	    return true;
    }
    catch(e)
    {
        alert(e);
    }
	
}
function RSWNodeRename()
{
/*----------------------------------------------
    功能：修改一对象的名字
----------------------------------------------*/
    try{
      
        var tree = document.getElementById("RSWNTree");               //取的数据源生成的树
        var tds = tree.database.GetDataSources();                     //取的与树绑定的数据源   
        var ds=tds.getNext();
            
        var c = tree.currentIndex;
        if(c<0)
        {
            RSAlertLocal("ChoiceIO");
            return;
        }
        var rs = tree.builderView.getResourceAtIndex(c); 
        var id = rs.Value;
        
        
        var retVals = {name: null ,ok: null};
        var Rename=document.getElementById("strings").getString("Rename");
        wnd = window.openDialog("RSRenameDialog.xul",Rename,"modal=yes,dependent:yes",retVals);
        if(retVals.ok==true)
        {
             var renode = g_w.AllNodes.getValue(id);                   //取的与选中节点对应的WORKSPACENODE对象
            if(renode.Status==0)                                       //判断节点的状态，只要处于关闭状态 的节点才可以改名
            { 
              if(renode.Name!=retVals.name)                            //判断修改之后是否和之前相同
              {
                renode.Name=retVals.name;                              //修改节点的名字
                renode.Save();                                         //保存到数据库中
	            var rdf = CC['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
	            var prd = rdf.GetResource("http://realso.cn/rdf/workspace/node#Name");  //由修改的predicat生成一RDFRESOURCE对象
	            var tar = rdf.GetLiteral(retVals.name);                //由修改后的名字生成一RDFNode对象
	            ds = ds.QueryInterface(CI.nsIRDFDataSource);           //取的数据源的nsIRDFDataSource接口
	            var oldTars = ds.GetTarget(rs,prd,true);               //由resource和predicate取得修改前名字生成的RDFNode对象
	            ds.Change(rs,prd,oldTars,tar);                         //在内存中的数据源修改节点名
	            tree.builder.rebuild();                                //刷新内存中的树，显示修改后的名字
    	        
              }
              else
                RSAlertLocal("SameName");
            }
            else
                RSAlertLocal("CannotR");
        }
    }
    catch(e){
        alert(e);
    }
 
}
function RSWNodeDelete()
{
/*------------------------------------------------------
    功能：删除一节点
------------------------------------------------------*/
    try{
        var tree = document.getElementById("RSWNTree");
        var tds = tree.database.GetDataSources();
        var ds=tds.getNext();
        var c = tree.currentIndex;
        if(c<0)
        {
            RSAlertLocal("ChoiceDO");
            return;
        }
        var rs = tree.builderView.getResourceAtIndex(c); 
        var id = rs.Value;
        var delnode1 = g_w.AllNodes.getValue(id);              //取得要删除的节点的workspacenode对象
        delnode = delnode1.QueryInterface(CI.nsIRSWorkspaceNode); 
            if(delnode.Status==0)
            {   
                var sConfirm = document.getElementById("strings").getString("ConfirmD");
                if(window.confirm(sConfirm)==true)
                {
                    delnode.Remove();                          //从数据库中删除此对象
                    var dba = CC["@realso.cn/XPCOM/RSDBAccess;1"].getService(CI.IRSDBAccess);//删除RDFModel表中Id对应的数据
                    var strError;
                    const cid1 = "@mozilla.org/supports-array;1";
                    obj1 = Components.classes[cid1].createInstance();
		            obj1 = obj1.QueryInterface(Components.interfaces.nsISupportsArray);
                    const cid3 = "@mozilla.org/variant;1";
                    wvrt1=Components.classes[cid3].createInstance();
		            wvrt1 =wvrt1.QueryInterface(Components.interfaces.nsIWritableVariant);
		            wvrt1.setAsInt32(id);
		            obj1.AppendElement(wvrt1);
		            var exeres=dba.Execute('0428','1.0',obj1,strError); //删除RDFModel表中Id对应的数据                                          
                    
                    var rdf = CC['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
	                var prd = rdf.GetResource("http://realso.cn/rdf/workspace/node#Name");
	                ds = ds.QueryInterface(CI.nsIRDFDataSource);
	                var oldTars = ds.GetTarget(rs,prd,true);
	                ds.Unassert(rs,prd,oldTars);               //在内存中的数据源中删除要删除的节点
	                tree.builder.rebuild();                    //在内存中刷新RDF树
	            }
            }
            else
            {
                RSAlertLocal("CannotDN");
            }
      
        
     }
    catch(e)
    {
        alert(e);
    }
}
function RSWXULCreate(FilePath, FileName)
{
/*-----------------------------------------------------
    功能：创建一workspacenode文件类型节点并返回
------------------------------------------------------*/
    try
    {
        var tree = document.getElementById("RSWNTree");
        var tds = tree.database.GetDataSources();
        var ds=tds.getNext();       
        var c = tree.currentIndex;
        if(c<0)
        {
            RSAlertLocal("ChoiceANP");
            return;
        }
        var rs = tree.builderView.getResourceAtIndex(c); 
        
        var id = rs.Value;
        adnode = g_w.CreateNode(3);                   //创建一文件类型的节点
        adnode.Name = FileName;                       //节点的NAME属性赋值
        adnode.Path = FilePath;                       //节点的NAME属性赋值

        var parent = g_w.AllNodes.getValue(id);       //根据ID取的workspacenode对象
        parent.AppendChild(adnode);                     //把创建的节点插入到父节点的子节点中

        adnode = adnode.QueryInterface(CI.nsIRSXULDocument);
        return adnode;                                //返回新建节点
    }
    catch(e)
    {
     alert(e);
    }
    
}
function RSWNodeAdd()
{
/*-----------------------------------------------------------
    功能：添加一已有文件到导航树中
-----------------------------------------------------------*/
    try{
       
        var file = RSWDialogOpenFile();              //打开一对话框供选择打开的文件
        if(file == null) return;
        var filepath = file.path;                    //打开文件的路径,在这没有用到此变量
        var filename = file.leafName;                //打开文件的文件名
        var xuldoc = RSWXULCreate(filepath,filename);//根据打开的文件名新建一节点
        //由RSWDialogOpenFile返回的file创建一url,在OpenXMLFile()用到此类型的变量做为参数
        var ios = CC["@mozilla.org/network/io-service;1"].getService(CI.nsIIOService); 
        var fileHandler = ios.getProtocolHandler("file").QueryInterface(CI.nsIFileProtocolHandler); 
        var URLSpec = fileHandler.getURLSpecFromFile(file); 
        xuldoc.OpenXMLFile(filepath);
        xuldoc.SaveXML();
        xuldoc.CloseXML();                             //把文件的状态改为关闭状态
       
        var tree = document.getElementById("RSWNTree");
        var tds = tree.database.GetDataSources();
        var ds = tds.getNext();
        
        var c = tree.currentIndex;
        var rs = tree.builderView.getResourceAtIndex(c); 
        xuldoc.AddToRDF(ds);                          //把新添加的节点添加到RDF中

        var rsc = rdfs.GetResource(xuldoc.ID);
        
        var cont = conunit.MakeSeq(ds, rs);
        
        cont.AppendElement(rsc);                 //在rdf容器中添加此节点

        tree.builder.rebuild();                      //刷新RDF树

   
    }
    catch(e)
    {
        alert(e);
    }
    
} 

function RSWNodeProperty()
{
/*-----------------------------------------------------
 功能：显示当前节点的属性
-----------------------------------------------------*/
    try{
        var tree = document.getElementById("RSWNTree");         
        var tds = tree.database.GetDataSources();    //取的XUL中与树绑定的数据源。所有具有datasources属性的xul元素都有database属性，指向它的sIRDFDataSource对象。
        var ds = tds.getNext();
	    var c = tree.currentIndex;                   //取的当前被选中序号
	    if(c<0) {
	        RSAlertLocal("ChoiceFCO");
    	    return;
	    }
	    
	    var rs = tree.builderView.getResourceAtIndex(c);    //取得当前被选中的resource
	    var id = rs.Value;
        var node = g_w.AllNodes.getValue(id);       //根据ID取的workspacenode对象

	    var retVals = { type: node.Type, name: node.Name ,ok: false,path: node.Path, id: node.ID};   //打开一对话框
        var NewObject=document.getElementById("strings").getString("NewObject");
	    wnd = window.openDialog("NodeNew.xul",NewObject,"modal=yes,dependent:yes",retVals);
	    
	    if(retVals.ok == true)
	    {   
	        node.Name=retVals.name;                        //给节点的成员变量赋值
	        node.Path=retVals.path;                        //给节点的成员变量赋值
	        node.Save();
            var rdf = CC['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
	        var prd = rdf.GetResource("http://realso.cn/rdf/workspace/node#Name");  //由修改的predicat生成一RDFRESOURCE对象
	        var tar = rdf.GetLiteral(retVals.name);                //由修改后的名字生成一RDFNode对象
	        ds = ds.QueryInterface(CI.nsIRDFDataSource);           //取的数据源的nsIRDFDataSource接口
	        var oldTars = ds.GetTarget(rs,prd,true);               //由resource和predicate取得修改前名字生成的RDFNode对象
            ds.Change(rs,prd,oldTars,tar);                         //在内存中的数据源修改节点名

	        tree.builder.rebuild();                       //刷新内存中的RDF树
	    }
	}
	catch(e)
	{
	    alert(e);
	    return;
	}
}
////////////////////////////////////////////////////////////////////////////////////
  function RSWNodeOpen()
  {
    try{
    var tree = document.getElementById("RSWNTree");
    var tds = tree.database.GetDataSources();
    var c = tree.currentIndex;
    if(c<0) 
	{
        RSAlertLocal("ChoiceFO");
 	    return;
	}
    var rs = tree.builderView.getResourceAtIndex(c); 
    var id = rs.Value;
    var openode = g_w.AllNodes.getValue(id);
    
    // 判断用户权限
    var sys= GetSys();
    if(sys.HasPrivilege(id) == 0)
    {
        RSAlertLocal("NoPopedom");
        return;
    }
    
    //alert(openode.Type);
    if(openode.Type!=0)//node is file.
    {
      if(openode.Type==3)
        {
                if(openode.Status == 0)//nod is closed.
                {
                    var mtabs = document.getElementById("RSWEditTabtabs");
                    var mpanels = document.getElementById("RSWEditTabtabpanels");
                    var newtab= document.createElement("tab");
                    var newpanel= document.createElement("tabpanel");
                    //alert('created');
                    newtab.setAttribute("label",tree.view.getCellText(c,tree.columns[0]));
                    newtab.setAttribute("id",id);
                    var pnlid="panel"+id;
                    newpanel.setAttribute("id",pnlid);
                    mpanels.appendChild(newpanel);
                    mtabs.appendChild(newtab);
                    var selTab=document.getElementById('RSWEditTab');
                    //selTab.selectedTab=newtab;
                    openode.Status=1;
                    //alert("Begin XMLDocument");
	                //openode=openode.QueryInterface(CI.nsIRSXMLDocument);
    	            openode.OpenXML();// 从数据库中读取该文档的内容
                	 
    	            ///////////////////////////////////////////////////////////////////
    	                 ////Checking whether XMLDocument of openode is empty./////
    	            try{     
    	                var m_oriXMLDoc = openode.GetDOMDocument();
                	        
    	                if(m_oriXMLDoc.documentElement==null)
    	                  {
    	                    //If type of file is xul.
    	                    if(openode.Type==3)
    	                      {
    	                        var xmlVer   = '<?xml version="1.0"?>'
                                var xmlStyle = '<?xml-stylesheet href="chrome://global/skin/" type="text/css"?>'
    	                        var xulString="<window xmlns='http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul' xmlns:html='http://www.w3.org/1999/xhtml'/>"
                                var parser    = new DOMParser();
                                var resultDoc = parser.parseFromString(xulString,"text/xml");
                                // add some processingInstruction
                                var m_ver     = resultDoc.createProcessingInstruction('xml','version="1.0"');
                                var m_sty     = resultDoc.createProcessingInstruction('xml-stylesheet','href="chrome://global/skin/" type="text/css"');
                                var styTree = "href='"+RSGetCSSDir()+"xbl.css"+"' "+"type='text/css'";
                                var m_sty     = resultDoc.createProcessingInstruction('xml-stylesheet','href="chrome://global/skin/" type="text/css"');
                                var m_styTree     = resultDoc.createProcessingInstruction('xml-stylesheet',styTree);
                                resultDoc.insertBefore(m_ver,resultDoc.documentElement);
                                resultDoc.insertBefore(m_sty,resultDoc.documentElement);
                                resultDoc.insertBefore(m_styTree,resultDoc.documentElement);
                                
                                // add some js file
                                // There is need to use createElementNS instead of createElement.
                                // Using createElement, script element will have extra attribute xmlns=''
                                var rstreeJS = resultDoc.createElementNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul','script');
                                var rsmenulistJS = resultDoc.createElementNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul','script');
                                var commonJS = resultDoc.createElementNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul','script');
                                rstreeJS.setAttribute('src',RSGetRootDir()+'/Treeview.js');
                                rsmenulistJS.setAttribute('src',RSGetRootDir()+'/css/MenuList.js');
                                commonJS.setAttribute('src',RSGetRootDir()+'/common.js');
                                resultDoc.documentElement.appendChild(rstreeJS);
                                resultDoc.documentElement.appendChild(rsmenulistJS);
                                resultDoc.documentElement.appendChild(commonJS);
    	                        openode.SetDOMDocument(resultDoc);
    	                      }
    	                  }
                	      
    	            }catch(e)
    	                  {
    	                    alert(e);
    	                  }
    	            ///////////////////////////////////////////////////////////////////
                	
                    //alert("Begin XULDocument");
	                //openode=openode.QueryInterface(CI.nsIRSXULDocument);
	                openode.OpenXUL();// 初始化读出的XUL文档
                    //alert("end XULDocument");
	                RSWXULShow(openode,newpanel,newtab);
                }
                else
                {
                    //alert("此对象已经被打开！");
                    var mtabs  = document.getElementById("RSWEditTabtabs");
                    var mAlltab = mtabs.getElementsByTagName('tab');
                    for(var i=0;i<mAlltab.length;i++)
                    {
                        if(id==mAlltab.item(i).id)
                          {
                              var selTab=document.getElementById('RSWEditTab');
                              selTab.selectedTab = mAlltab.item(i);
                          } 
                    }
                }
        }
         
          if(openode.Type==6)
            {
                if(openode.Status == 0)
                  {
                    var mtabs = document.getElementById("RSWEditTabtabs");
                    var mpanels = document.getElementById("RSWEditTabtabpanels");
                    var newtab= document.createElement("tab");
                    var newpanel= document.createElement("tabpanel");
                    //alert('created');
                    newtab.setAttribute("label",tree.view.getCellText(c,tree.columns[0]));
                    newtab.setAttribute("id",id);
                    var pnlid="panel"+id;
                    newpanel.setAttribute("id",pnlid);
                    mpanels.appendChild(newpanel);
                    mtabs.appendChild(newtab);
                    var selTab=document.getElementById('RSWEditTab');
                    selTab.selectedTab=newtab;
                    openode.Status = 1;
                    
                    var m_rdfConfig = document.createElement('iframe');
                   
                    m_rdfConfig.setAttribute('flex','1');
                    m_rdfConfig.setAttribute('ModelID',id);
                    m_rdfConfig.setAttribute('ModelName',openode.Name);
//                    m_rdfConfig.setAttribute('height','600');
//                    m_rdfConfig.setAttribute('width','600');
                    RSWSchemaShow(m_rdfConfig ,newpanel);
                  }
                   else
                   {
                       //alert("此对象已经被打开！");
                       var mtabs  = document.getElementById("RSWEditTabtabs");
                       var mAlltab = mtabs.getElementsByTagName('tab');
                       for(var i=0;i<mAlltab.length;i++)
                       {
                            if(id==mAlltab.item(i).id)
                              {
                                  var selTab=document.getElementById('RSWEditTab');
                                  selTab.selectedTab = mAlltab.item(i);
                              } 
                       }
                   }
            }
          if(openode.Type==7)
            {
                if(openode.Status == 0)
                  {
                    var mtabs = document.getElementById("RSWEditTabtabs");
                    var mpanels = document.getElementById("RSWEditTabtabpanels");
                    var newtab= document.createElement("tab");
                    var newpanel= document.createElement("tabpanel");
                    //alert('created');
                    newtab.setAttribute("label",tree.view.getCellText(c,tree.columns[0]));
                    newtab.setAttribute("id",id);
                    var pnlid="panel"+id;
                    newpanel.setAttribute("id",pnlid);
                    mpanels.appendChild(newpanel);
                    mtabs.appendChild(newtab);
                    var selTab=document.getElementById('RSWEditTab');
                    selTab.selectedTab=newtab;
                    openode.Status = 1;
                    
                    var m_rdfConfig = document.createElement('iframe');
                   
                    m_rdfConfig.setAttribute('flex','1');
                    m_rdfConfig.setAttribute('ModelID',id);
                    m_rdfConfig.setAttribute('ModelName',openode.Name);
                    m_rdfConfig.setAttribute('src','chrome://RealSo/content/APP/SS/RSDBLink.xul');
                    newpanel.appendChild(m_rdfConfig);
                  }
                   else
                   {
                      //alert("此对象已经被打开！");
                       var mtabs  = document.getElementById("RSWEditTabtabs");
                       var mAlltab = mtabs.getElementsByTagName('tab');
                       for(var i=0;i<mAlltab.length;i++)
                       {
                            if(id==mAlltab.item(i).id)
                              {
                                  var selTab=document.getElementById('RSWEditTab');
                                  selTab.selectedTab = mAlltab.item(i);
                              } 
                       }
                   }
            }
          if(openode.Type==8)
            {
                if(openode.Status == 0)
                  {
                    var mtabs = document.getElementById("RSWEditTabtabs");
                    var mpanels = document.getElementById("RSWEditTabtabpanels");
                    var newtab= document.createElement("tab");
                    var newpanel= document.createElement("tabpanel");
                    //alert('created');
                    newtab.setAttribute("label",tree.view.getCellText(c,tree.columns[0]));
                    newtab.setAttribute("id",id);
                    var pnlid="panel"+id;
                    newpanel.setAttribute("id",pnlid);
                    mpanels.appendChild(newpanel);
                    mtabs.appendChild(newtab);
                    var selTab=document.getElementById('RSWEditTab');
                    selTab.selectedTab=newtab;
                    openode.Status = 1;
                    
                    var m_rdfConfig = document.createElement('iframe');
                   
                    m_rdfConfig.setAttribute('flex','1');
                    m_rdfConfig.setAttribute('ModelID',id);
                    m_rdfConfig.setAttribute('ModelName',openode.Name);
                    m_rdfConfig.setAttribute('src','chrome://RealSo/content/APP/SS/RSDBSQL.xul');
                    newpanel.appendChild(m_rdfConfig);
                  }
                   else
                   {
                       //alert("此对象已经被打开！");
                       var mtabs  = document.getElementById("RSWEditTabtabs");
                       var mAlltab = mtabs.getElementsByTagName('tab');
                       for(var i=0;i<mAlltab.length;i++)
                       {
                            if(id==mAlltab.item(i).id)
                              {
                                  var selTab=document.getElementById('RSWEditTab');
                                  selTab.selectedTab = mAlltab.item(i);
                              } 
                       }
                   }
            }
            
            // Open node is a USERGROUP_NODE
            if(110==openode.Type)
            {
                if(openode.Status == 0)
                  {
                    var mtabs = document.getElementById("RSWEditTabtabs");
                    var mpanels = document.getElementById("RSWEditTabtabpanels");
                    var newtab= document.createElement("tab");
                    var newpanel= document.createElement("tabpanel");
                    //alert('created');
                    newtab.setAttribute("label",tree.view.getCellText(c,tree.columns[0]));
                    newtab.setAttribute("id",id);
                    var pnlid="panel"+id;
                    newpanel.setAttribute("id",pnlid);
                    mpanels.appendChild(newpanel);
                    mtabs.appendChild(newtab);
                    var selTab=document.getElementById('RSWEditTab');
                    selTab.selectedTab=newtab;
                    openode.Status = 1;
                    
                    var m_rdfConfig = document.createElement('iframe');
                   
                    m_rdfConfig.setAttribute('flex','1');
                    m_rdfConfig.setAttribute('ModelID',id);
                     
                    m_rdfConfig.setAttribute('ModelName',openode.Name);
                    m_rdfConfig.setAttribute('src','chrome://RealSo/content/APP/SS/RSUserGroup.xul');
                    newpanel.appendChild(m_rdfConfig);
                  }
                    else
                    {
                       //alert("此对象已经被打开！");
                       var mtabs  = document.getElementById("RSWEditTabtabs");
                       var mAlltab = mtabs.getElementsByTagName('tab');
                       for(var i=0;i<mAlltab.length;i++)
                       {
                            if(id==mAlltab.item(i).id)
                              {
                                  var selTab=document.getElementById('RSWEditTab');
                                  selTab.selectedTab = mAlltab.item(i);
                              } 
                       }
                    }
            }
            // Open node is a USER_NODE
            if(111==openode.Type)
            {
                if(openode.Status == 0)
                  {
                    var mtabs = document.getElementById("RSWEditTabtabs");
                    var mpanels = document.getElementById("RSWEditTabtabpanels");
                    var newtab= document.createElement("tab");
                    var newpanel= document.createElement("tabpanel");
                    //alert('created');
                    newtab.setAttribute("label",tree.view.getCellText(c,tree.columns[0]));
                    newtab.setAttribute("id",id);
                    var pnlid="panel"+id;
                    newpanel.setAttribute("id",pnlid);
                    mpanels.appendChild(newpanel);
                    mtabs.appendChild(newtab);
                    var selTab=document.getElementById('RSWEditTab');
                    selTab.selectedTab=newtab;
                    openode.Status = 1;
                    
                    var m_rdfConfig = document.createElement('iframe');
                   
                    m_rdfConfig.setAttribute('flex','1');
                    m_rdfConfig.setAttribute('ModelID',id);
                    m_rdfConfig.setAttribute('ModelName',openode.Name);
                    m_rdfConfig.setAttribute('src','chrome://RealSo/content/APP/SS/RSUser.xul');
                    newpanel.appendChild(m_rdfConfig);
                  }
                    else
                    {
                       //alert("此对象已经被打开！");
                       var mtabs  = document.getElementById("RSWEditTabtabs");
                       var mAlltab = mtabs.getElementsByTagName('tab');
                       for(var i=0;i<mAlltab.length;i++)
                       {
                            if(id==mAlltab.item(i).id)
                              {
                                  var selTab=document.getElementById('RSWEditTab');
                                  selTab.selectedTab = mAlltab.item(i);
                              } 
                       }
                    }
            }
         
    }
        else
        {
            //alert("不可以打开文件夹！");
        }
    }
    catch(e){
    alert('workspace.js RSWNodeOpen() '+e);
    }
  }
////////////////////////////////////////////////////////////////////////////////////
function RSWNodeClose()
{
	try
	{
	 var tree = document.getElementById("RSWNTree");
    	 var tds = tree.database.GetDataSources();
    	 var c = tree.currentIndex;
    	 if(c<0) 
	 {
          RSAlertLocal("ChoiceFC");
 	  return;
	 }
	    
    var rs = tree.builderView.getResourceAtIndex(c); 
    var id = rs.Value;
    var clonode = g_w.AllNodes.getValue(id);
    if(clonode.Status !=0)
    {
        var mtabs = document.getElementById("RSWEditTabtabs");
        var mpanels = document.getElementById("RSWEditTabtabpanels");
     
        var dtab=document.getElementById(id);
        var pnlid="panel"+id;
        var dpanel=document.getElementById(pnlid);
        var ggg=document.getElementById('RSWEditTab');
        var s= ggg.selectedIndex;       
        mtabs.removeChild(dtab);
        mpanels.removeChild(dpanel);
	     //var serializer = new XMLSerializer();
             //xml = serializer.serializeToString(mpanels);
             //alert(xml);
        if(s!=0)
        {
          
          ggg.selectedIndex=s-1;
        }
        else
        {
          ggg.selectedIndex=0;
         
        }
        
        if(clonode.Type==3){
	        clonode.CloseXML();
	        clonode.CloseXUL();
	    }
        clonode.Status = 0;
    }
    else
        RSAlertLocal("CannotCNOO");
	}
	catch(e)
	{
	 alert(e);	
	}
}
////////////////////////////////////////////////////////////////////////
function RSWNodeSave()
{
	try
	{
	    var tree = document.getElementById("RSWNTree");

        var c = tree.currentIndex;
        if(c<0) 
	    {
            RSAlertLocal("ChoiceFS");
 	        return;
	    }
	    
    	var rs = tree.builderView.getResourceAtIndex(c); 
    	var id = rs.Value;
    	var savenode = g_w.AllNodes.getValue(id).QueryInterface(CI.nsIRSXMLDocument);
		savenode.SaveXML();
		RSAlertLocal("SaveS");
	}
	catch(e)
	{
	 alert(e);
	}  


}

// 更新节点的本地镜像
function RSWNodeUpdate()
{
    try
    {
        var b = window.confirm(document.getElementById("strings").getString("ConfirmC"));
        if(b==false) return;
        var tree = document.getElementById("RSWNTree");
        var c = tree.currentIndex;
        if(c<0) 
        {
            RSAlertLocal("ChoiceFU");
            return;
        }
        var rs = tree.builderView.getResourceAtIndex(c); 
        var id = rs.Value;
        var node = g_w.AllNodes.getValue(id);

        RSWNodeUpdateOne(node);
        RSAlertLocal("UpdataS");
    }
    catch(e)
    {
        alert(e+"\n In RSWXUL.js->RSWNodeUpdate()");
    }  
}

//
function RSWNodeUpdateOne(node){
    try
    {   //更新本节点的本地镜像
        if(node.Type == 3)
        {
            if(node.Path.length == 0) 
            {
                // 没有设置本地相对路径
            }
            else
            {
                node = node.QueryInterface(CI.nsIRSXMLDocument);
                var path = RSGetPath(node.Path+node.Name);
                if(node.Status == 0)
                {
                    node.OpenXML();// 从数据库中读取该文档的内容
                    node.SaveXMLFile(path);
                    node.CloseXML();
                }
                else
                {
                    node.SaveXMLFile(path);
                }
            }
        }
        // 更新下属节点的本地镜像
        var count = new Number();
        var array = new Array();
        array = node.ChildNodes.getKeys(count);
        for(var c = 0; c < count.value; c++){
            RSWNodeUpdateOne(node.GetChild(array[c]));
        }
    }
    catch(e){alert(e+"\nIn RSWXUL.js->RSWNodeUpdateOne()");}
}

// 初始化Workspace
//
function RSWWindowLoadWorkspace() {
    try{
        g_w.Load();
        ds = g_w.GetDataSource();
        var tree = document.getElementById("RSWNTree");
        var tds = tree.database.GetDataSources();
        while (tds.hasMoreElements())
            tree.database.RemoveDataSource(tds.getNext());
        tree.database.AddDataSource(ds);
        tree.builder.rebuild();
        //RSWWindowAddIcon();            此函数还有问题
    }
    catch(e){
        alert(e);
    }
}

function RSWWindowLoadProperty()
{
 //fminit();       属性栏作为Dialog,此处可以不做
 RSWXULEdit_init();
}

function RSWWindowLoad()
 {
       try
        { 
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        document.getElementById("RSWTitleBar").DoResize();
        var retVals = { ok: null};
        window.openDialog("Login.xul","dlg", "modal,minimizable",retVals );
        if(retVals.ok==null)
        {
            window.close(); 
            return;
        }
        g_w = CC["@realso.cn/RSWorkspace;1"].createInstance(CI.nsIRSWorkspace);
        g_w.IDEDocument =document;
        
        window.name = 'realso integrated development environment';
        RSWWindowLoadWorkspace();
        document.getElementById('btRSWTBBack').disabled=true;
        document.getElementById('btRSWTBFwd').disabled=true;
          
        document.addEventListener('mouseup',RSW_clear_message,true);
        
        window.addEventListener('resize',RSW_move_message,false);
       }
      catch(e)
         {
           alert('catch two error!');
           alert(e);
         }
    RSWWindowLoadProperty();
}

function RSWWindowAddIcon()
{   
    try
    {
        //var node = Object();
        var count = new Number();
         
        var akeys = new Array(20);
        
        //dictionary = CC["@mozilla.org/dictionary;1"].createInstance(CI.nsIDictionary);
        
      //  dictionary = g_w.AllNodes;                  //AllNodes是否为空
        //alert(g_w.AllNodes);
        g_w.AllNodes.getKeys(count,akeys);
        alert(count.value);
       // alert(akeys[2]);
        for(var i=0;i<count.value;i++)
        {   
            node = g_w.AllNodes.getValue(i);
           // alert(node.Type);
            if(node.Type==0)
            {       
                var tcell = document.getElementById("treecell");
                tcell.setAttribute("src","img/folder.gif");   
            }
            if(node.Type==3)
            {
                var tcell = document.getElementById("treecell");
                tcell.setAttribute("src","img/dog.gif");  
            }
        }

    }
    catch(e)
    {
        //alert('catch fff');
        alert(e);
    }  
        
}

function RSWViewShowHide()
{
   try
   {  
      if(RSWViewShowHide_flag==1)
      {
         document.getElementById('workspace_navigator').setAttribute("hidden","true");
         RSWViewShowHide_flag=0;
      }
      else
      {
         if(RSWViewRelatedInfo_flag==1)
         {
           document.getElementById('RSWRelatedInfo').setAttribute("hidden","true");
           RSWViewRelatedInfo_flag=0;
           
         }
         document.getElementById('workspace_navigator').setAttribute("hidden","false");
         RSWViewShowHide_flag=1;
      }
   }
   catch(e)
   {
       alert("RSWXULMenuView.js "+"RSWViewShowHide():"+e);
   }
   
}

function RSWViewRelatedInfo()
{
   if(RSWViewShowHide_flag==1)
   {
      document.getElementById('workspace_navigator').setAttribute("hidden","true");
      RSWViewShowHide_flag=0;
      document.getElementById('RSWRelatedInfo').setAttribute("hidden","false");
      RSWViewRelatedInfo_flag=1;
   }
   else
   {
      document.getElementById('RSWRelatedInfo').setAttribute("hidden","false");
      RSWViewRelatedInfo_flag=1;
   }
}

function RSWUnLoad()
{
    g_w = null;
}