﻿// ============================================================================
//
// = 目录
//       chrome/realso
//
// = 文件名
//      common.js
//
// = 描述
//      常用函数。
//      
// = 作者
//      干劲 javajin@hotmail.com
//      李杰
//      邓东东
//      袁立山
//      查琦
//
// == 历史
//      0317：代码规范化。Alpha 1.0版本形成
//
// == 待处理
//      
// ============================================================================

/*
  全局变量申明
*/
const CC = Components.classes, CI = Components.interfaces; 
var rdfs = CC["@mozilla.org/rdf/rdf-service;1"].getService(CI.nsIRDFService);
var conunit = CC["@mozilla.org/rdf/container-utils;1"].getService(CI.nsIRDFContainerUtils);

 

// 打开一个本地文件，返回nsILocalFile
    // 文件名：file.leafName
    // 文件大小：file.fileSize 
    // 文件路径（带文件名）：file.path
    // 文件路径（不带文件名，带最后一个\）：file.path.substr(0,file.path.length-file.leafName.length)  
    //      var str= file.path;
    //      alert(str.substr(0,str.length-file.leafName.length)  );
    // 文件URL：
    //      work with returned nsILocalFile... 
    //      var ios = CC["@mozilla.org/network/io-service;1"].getService(CI.nsIIOService); 
    //      var fileHandler = ios.getProtocolHandler("file").QueryInterface(CI.nsIFileProtocolHandler); 
    //      var URLSpec = fileHandler.getURLSpecFromFile(file); 
function RSWDialogOpenFile() { 

  var fp = CC["@mozilla.org/filepicker;1"].createInstance(CI.nsIFilePicker); 
  fp.init(window, "打开文件", CI.nsIFilePicker.modeOpen); 
  fp.appendFilters(CI.nsIFilePicker.filterAll | CI.nsIFilePicker.filterText); 

  var rv = fp.show(); 
  if (rv == CI.nsIFilePicker.returnOK){ 
    var file = fp.file; 
    return file;
  } 
  else{
    return null;
  }
} 
/////////////////////////////////////////////////////////////////////////////////////////////
// 求文件的相对路径
// 输入：:
//      reltivFPath：需要得到的文件相对于根目录的路径：a/b/c.xul，
//      Protocal：协议，如果等于"file"，返回file协议路径，否则，返回真实路径
// 输出： 文件的URI
//        file协议：file:///c:\xulrunner\test\chrome\test\a.xml
//        非file协议：c:\xulrunner\test\chrome\test\a.xml
/////////////////////////////////////////////////////////////////////////////////////////////

function RSGetPath(reltivFPath,Protocol)
{ //Return the given file's absolute path.
    try
    {
        var path = 'chrome/RealSo'+reltivFPath;//Relative path of .rdf file.
        var objprotocal = CC["@mozilla.org/network/protocol;1?name=file"]
                            .createInstance(CI.nsIFileProtocolHandler);
        var id="erp@realso.cn";
        var file ;
        var loc = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(CI.nsIExtensionManager)
                    .getInstallLocation(id);
        if(loc != null)
            file = loc.getItemLocation(id); 
                    
        if(!file)
            file = CC["@mozilla.org/file/directory_service;1"]
                        .getService(CI.nsIProperties).get("CurProcD", CI.nsIFile);
                    
        var fileUri = objprotocal.getURLSpecFromFile(file);
        if (path.indexOf('/') >= 0)
        {
            var pathArr = path.split('/');
            for (var i = 0; i < pathArr.length; i++){
                file.append(pathArr[i]);
                }
        }
        else if (path.indexOf('\\') >= 0)
        {
            var pathArr = path.split('\\');
            for (var i = 0; i < pathArr.length; i++)
                file.append(pathArr[i]);
        }
        else
        {
            var pathArr = path;
            file.append(pathArr);
        }
        
        //Get the URI of the file.
        var fileUri = objprotocal.getURLSpecFromFile(file);
        if(Protocol == "file")
            return fileUri;
        else
            return file.path;
    }
    catch(e)
    {
        RSAlert(e + '\nHappened in RSGetPath method!');
    }
}

// 序列化xml到一个字符串
function RSSerialize(ds,txt)
{       
    try
    {
        var s = Components.classes["@mozilla.org/rdf/xml-serializer;1"].createInstance(Components.interfaces.nsIRDFXMLSerializer);
        s.init(ds);
        var outputStream1 = {
            data: "",
            close : function(){ RSAlert('close');},
            flush : function(){ RSAlert('flush');},
            write : function (buffer,count){
            this.data += buffer;
            //alert(this.data);
            return count;
            },
            writeFrom : function (stream,count){ RSAlert('wf');},
            writeSegments : function (reader ,closure ,count ){ RSAlert('wf');},
            isNonBlocking : function (){return false;},
        };
        s = s.QueryInterface(Components.interfaces.nsIRDFXMLSource);

        s.Serialize(outputStream1);
        var tb= document.getElementById(txt);
        tb.value = outputStream1.data;
    }
    catch(e){RSAlert(e+"\n In common.js->RSSerialize()"); }
}

function RSGetCSSDir()
{
    return "chrome://RealSo/content/css/";
}
function RSGetRootDir()
{
    return "chrome://RealSo/content";
}

/* *******************************************************************************
 * This function is for Disabled elements according to the passed list of ID.  The 
 * parameters of this function is changable, like RSFDisabled(...). But, the first
 * parameter is a boolean, true for disabled and false for enable.Follow the first
 * parameter is a list of ID, eg. RSFDisabled(true,'id_button1','id_label1').
 * *******************************************************************************
 */
function RSFDisabled(bool_value)
{
 try{
     for(var i=1;i<arguments.length;i++)
     {
        var tempEle = document.getElementById(arguments[i]);
        if(null!=tempEle)
            tempEle.setAttribute('disabled',bool_value);
     }
 }catch(e){
    RSAlert('common.js RSFDisabled() '+e);
    throw e;
 }
}

/* *******************************************************************************
 * It's for hidden elements, reference RSFDisabled() function.
 * *******************************************************************************
 */
function RSFHidden(bool_value)
{
 try{
     for(var i=1;i<arguments.length;i++)
     {
        var tempEle = document.getElementById(arguments[i]);
        if(null!=tempEle)
            tempEle.setAttribute('hidden',bool_value);
     }
 }catch(e){
    RSAlert('common.js RSFHidden() '+e);
    throw e;
 }
}

/* *******************************************************************************
 * It's for setting attribute of  elements, reference RSFDisabled() function.
 * *******************************************************************************
 */
function RSFsetAttribute(attribute_name,attribute_value)
{
 try{
     for(var i=2;i<arguments.length;i++)
     {
        var tempEle = document.getElementById(arguments[i]);
        if(null!=tempEle)
            tempEle.setAttribute(attribute_name,attribute_value);
     }
 }catch(e){
    RSAlert('common.js RSFHidden() '+e);
    throw e;
 }
}

/* *******************************************************************************
 * It's for removing attribute of  elements, reference RSFDisabled() function.
 * *******************************************************************************
 */
function RSFremoveAttribute(attribute_name)
{
 try{
     for(var i=1;i<arguments.length;i++)
     {
        var tempEle = document.getElementById(arguments[i]);
        if(null!=tempEle)
            tempEle.removeAttribute(attribute_name);
     }
 }catch(e){
    RSAlert('common.js RSFHidden() '+e);
    throw e;
 }
}

/* *******************************************************************************
 * No matter how many parameters are given, the function return a nsISupportsArray
 * component, it contains all the input parameter.
 * *******************************************************************************
 */
function RSFCreateParameters()
{
 try{
     //alert(arguments.length);
     var cid = "@mozilla.org/supports-array;1";
     var pSupportsArray = CC[cid].createInstance();
     pSupportsArray = pSupportsArray.QueryInterface(CI.nsISupportsArray);
     
     for(var i=0;i<arguments.length;i++)
     {
        cid = "@mozilla.org/variant;1";
        var v = CC[cid].createInstance();
        v = v.QueryInterface(CI.nsIWritableVariant);
        v.setAsWString(arguments[i]);
        pSupportsArray.AppendElement(v);
     }
     
     return pSupportsArray;
 }catch(e){
      RSAlert('common.js RSFCreateParameters() '+e);
      throw e;
 }
}

/* *******************************************************************************
 * If there is not a parameter, pSupportsArray will be null. In this case, create
 * a empty nsISupportsArray.
 * *******************************************************************************   
 */
function RSFInitDataSource(pSupportsArray)
{
   try{
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var cid = "@realso.cn/RSRdfDB;1";
        var obj = CC[cid].createInstance();
        obj = obj.QueryInterface(CI.nsIRSRdfDB);
        
        if(null==pSupportsArray)
        {
            cid = "@mozilla.org/supports-array;1";
            pSupportsArray = CC[cid].createInstance();
            pSupportsArray = pSupportsArray.QueryInterface(CI.nsISupportsArray);
            cid = "@mozilla.org/variant;1";
            //var v = CC[cid].createInstance();
            //v = v.QueryInterface(CI.nsIWritableVariant);
            //v.setAsWString('0101');
            //pSupportsArray.AppendElement(v);
        }
        // set a new property to the document and window object
        document.RSDataSource = obj;
        window.RSDataSource   = obj;
        obj.RSFDataInit(document,pSupportsArray);
   }catch(e){
       RSAlert('common.js RSFInitDataSource() '+e);
       throw e;
   }
}
function RSFTreeMoveTo(sourTreeid,destTreeid)
{   /*
    函数功能：把某一Tree中的一行移动到另一个Tree中，并从原Tree中把移动的那行删除
    */
    try
    {
        var sourTree =document.getElementById(sourTreeid);
        var destTree =document.getElementById(destTreeid);
        var sourView = sourTree.orientalView;
        var destView = destTree.orientalView;
        var sourRowcount = sourView.rowCount
        var sourSelect = sourView.selection;
        var sourSecount = sourSelect.count;
        var selectionIndex ;
        var selectStart = sourSelect.shiftSelectPivot;
        var count = sourSecount;
        var rangcount = sourSelect.getRangeCount();
        var rangarray = new Array();
        var index1 = new Object();
        var index2 = new Object();
        //var num;
        //选择的行数大于一，即多选的情况
        if(sourSecount>1)
        {   
            var m = sourTree.currentIndex;
            //按ctr选多个不连续的，或连续的
            for(var i=0;i<sourSecount;i++)
            {   //按ctr选择的连续的一个选区
                if(selectStart == -1 && rangcount == 1)
                {
                    rangarray[i] = m;
                    m --;
                 
                }
                //按ctr选中的多个单行的选区
                else
                {
                    sourSelect.getRangeAt(i,index1,index2);                  
                    rangarray[i] = index1.value;
                }

            }
            //按ctr选择的单个，多个连续的组成的选区
            if(selectStart == -1 && sourSecount > rangcount)
            {   var m = 0;
                for(var i=0;i<rangcount;i++)
                {
                    sourSelect.getRangeAt(i,index1,index2);
                    if(index1.value == index2.value)
                    {   //选区中只有一行
                        rangarray[m] = index1.value;
                        //alert('the Number:'+ m +' is '+index1.value);
                        m++;
                    }
                    else
                    {   //选区中有多行，保存每一行
                        for(var n = index1.value;n<=index2.value;n++)
                        {
                            rangarray[m] = n;
                            m++;
                        }
                    }                  
                }
            }
        }
        //升序排列
        rangarray.sort();  
        //
        while(count)
        {
            //按shift选择的一个多行的连续选区，取最后一个被选中的行作为操作对象。 
            if(sourSecount >1 && selectStart != -1)
            {   
                selectionIndex = selectStart + count -1;
            }
            else
            {    //选择是按ctr选择的多变的选区，则从保存选中行的数组中取最后一行作为要操作的行。
                if((selectStart == -1 && rangcount>1) || (sourSecount >1 && selectStart == -1))
                {
                    selectionIndex = rangarray[count-1];
                }
                else
                {   //直接选一行是的情况，就取当前行作为要操作的行
                    selectionIndex = sourTree.currentIndex;
                }
            }
            //取得要操作的行，把其所有字段的值取出，插入到另一个tree中
            sourTree.currentIndex = selectionIndex;
            var curIndex = sourTree.currentIndex;         
            if(curIndex >=0 && curIndex != sourRowcount-1)
            {
                var sourColums = sourTree.columns;
                var destColums = destTree.columns;
                var clumCount = sourColums.count;
                var destIndex = destView.rowCount-1;
                //遍历所有列
                for(var i = 0;i<=clumCount-1;i++)
                {
                    var sourColum = sourColums.getColumnAt(i);
                    var destColum = destColums.getColumnAt(i);
                    var sourValue = sourView.getCellText(curIndex,sourColum);
                    //向目的Tree中插入一列
                    destView.setCellText(destIndex,destColum,sourValue);
                }
                //把原始tree中的行删除
                var path = sourTree.getAttribute('RS_datasource');
                
                document.RSDataSource.RSFMoveTo(curIndex,path);
                sourView.delRow(curIndex);
                 
                sourView.treeBox.invalidate();
                
            }
            //改变当前行
           
            count--;
            sourSelect.clearRange(curIndex,curIndex);
            sourSelect.invalidateSelection(); 
        }
        sourSelect.clearSelection();
    }
    catch(e)
    {
        RSAlert('common.js '+' RSFTreeMoveTo '+ e);
    }
}

//set schema class info
function RSSCMAddSchema(memoryDS,obj)
  {
   try{
      var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
      var rdfContainerUtils=Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
      var subject;
      var predicate;
      var object;
      
         subject=RDF.GetResource("http://realso.cn/sqlhouse/"+obj.filename);
         var container=rdfContainerUtils.MakeSeq(memoryDS,subject);
         predicate=RDF.GetResource("http://realso.cn/rdf#Name");
         object=RDF.GetLiteral(obj.filename);
         memoryDS.Assert(subject,predicate,object,true);
         predicate=RDF.GetResource("http://realso.cn/rdf#Type");
         object=RDF.GetLiteral(obj.type);
         memoryDS.Assert(subject,predicate,object,true);
         predicate=RDF.GetResource("http://realso.cn/rdf#SQLID");
         object=RDF.GetLiteral(obj.sqlid);
         memoryDS.Assert(subject,predicate,object,true);
         predicate=RDF.GetResource("http://realso.cn/rdf#TableName");
         object=RDF.GetLiteral(obj.tablename);
         memoryDS.Assert(subject,predicate,object,true);
         predicate=RDF.GetResource("http://realso.cn/rdf#IsRoot");
         object=RDF.GetLiteral("true");
         memoryDS.Assert(subject,predicate,object,true);
         predicate=RDF.GetResource("http://realso.cn/rdf#ReadOnly");
         object=RDF.GetLiteral(obj.readonly);
         memoryDS.Assert(subject,predicate,object,true);
         predicate=RDF.GetResource("http://realso.cn/rdf#Location");
         object=RDF.GetLiteral(obj.location);
         memoryDS.Assert(subject,predicate,object,true);
     
       
   }catch(e){RSAlert(e);}
  }
  
//initialize necessary info of schema
function RSSCMInit(memoryDS)
  {
   try{
     var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
     var subject;
     var predicate;
     var object;
     subject=RDF.GetResource("http://www.w3.org/2001/XMLSchema#int");
     predicate=RDF.GetResource("http://realso.cn/rdf#Name");
     object=RDF.GetLiteral("int");
     memoryDS.Assert(subject,predicate,object,true);
     subject=RDF.GetResource("http://realso.cn/sqlhouse/Detailschema");
     object=RDF.GetLiteral("schema");
     memoryDS.Assert(subject,predicate,object,true);
     subject=RDF.GetResource("http://www.w3.org/2001/XMLSchema#string");
     predicate=RDF.GetResource("http://realso.cn/rdf#Name");
     object=RDF.GetLiteral("string");
     memoryDS.Assert(subject,predicate,object,true);

     subject=RDF.GetResource("http://www.w3.org/2001/XMLSchema#boolean");
     predicate=RDF.GetResource("http://realso.cn/rdf#Name");
     object=RDF.GetLiteral("boolean");
     memoryDS.Assert(subject,predicate,object,true);

     subject=RDF.GetResource("http://www.w3.org/2001/XMLSchema#hexBinary");
     predicate=RDF.GetResource("http://realso.cn/rdf#Name");
     object=RDF.GetLiteral("hexBinary");
     memoryDS.Assert(subject,predicate,object,true);
     subject=RDF.GetResource("http://www.w3.org/2001/XMLSchema#float");
     predicate=RDF.GetResource("http://realso.cn/rdf#Name");
     object=RDF.GetLiteral("float");
     memoryDS.Assert(subject,predicate,object,true);
     subject=RDF.GetResource("http://www.w3.org/2001/XMLSchema#dateTime");
     predicate=RDF.GetResource("http://realso.cn/rdf#Name");
     object=RDF.GetLiteral("dateTime");
     memoryDS.Assert(subject,predicate,object,true);
     
     subject=RDF.GetResource("http://www.w3.org/2001/XMLSchema#decimal");
     predicate=RDF.GetResource("http://realso.cn/rdf#Name");
     object=RDF.GetLiteral("decimal");
     memoryDS.Assert(subject,predicate,object,true);
   
   }catch(e){RSAlert(e);}
   
  }
  
//set field info of the schema,别用这个函数，暂时保留
function RSSCMAddField(memoryDS,oldDS,tablename)
  {
    try{

         var rdfContainerUtils=Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
         var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
         var tableURI=RDF.GetResource("http://realso.cn/sqlhouse/"+tablename);
         var container=rdfContainerUtils.MakeSeq(memoryDS,tableURI);
         var fieldsubs=container.GetElements();
           while(fieldsubs.hasMoreElements())
           {
           
            var fieldsub=fieldsubs.getNext();

            fieldsub=fieldsub.QueryInterface(Components.interfaces.nsIRDFResource);
            var fieldpres=oldDS.ArcLabelsOut(fieldsub);
            while(fieldpres.hasMoreElements())
            {
             var fieldpre=fieldpres.getNext();
             fieldpre=fieldpre.QueryInterface(Components.interfaces.nsIRDFResource);
             if(fieldpre.Value=="http://www.w3.org/2000/01/rdf-schema#range")
             {
              var nullnodesub=oldDS.GetTarget(fieldsub,fieldpre,true);
              nullnodesub=nullnodesub.QueryInterface(Components.interfaces.nsIRDFResource);
              var nullnodepres=oldDS.ArcLabelsOut(nullnodesub);
              while(nullnodepres.hasMoreElements())
              {
                var nullnodepre=nullnodepres.getNext();
                nullnodepre=nullnodepre.QueryInterface(Components.interfaces.nsIRDFResource);
                var nullnodeobj=oldDS.GetTarget(nullnodesub,nullnodepre,true);
                memoryDS.Assert(nullnodesub,nullnodepre,nullnodeobj,true);
              }
             }
             var fieldobj=oldDS.GetTarget(fieldsub,fieldpre,true);
   
             memoryDS.Assert(fieldsub,fieldpre,fieldobj,true);
            }
            
           } 
    
    
    }catch(e){RSAlert(e);}  
  
  }

// 加密
function RSFCoding(password)
  { 
    /*
    函数功能：按照SHA256加密
    */
    try
    {
        var cryp =CC["@mozilla.org/security/hash;1"].createInstance(CI.nsICryptoHash);
        cryp.init(4);
        var ay = new Array();
        for(var i = 0; i < password.length; i++)
        {
            var c = password.charCodeAt(i);
            ay[i]=c;
        }
        cryp.update(ay,password.length);
        var cpass = cryp.finish(true);
        return cpass;
    }
    catch(e)
    {
        RSAlert('common.js '+ ' RSFCoding ' + e);
    }
  }
/*
    函数功能：取当前日期返回
*/
 
function RSFGetNowDate()
{
    try
    {
        var SQLId  = '0510';
        var SQLVer = '1.0';
        var rsDBAccess  = CC["@realso.cn/XPCOM/RSDBAccess;1"].getService(CI.IRSDBAccess);
        var nSpprtPrmtr = RSFCreateParameters();
        var cid = "@mozilla.org/supports-string;1";
        var nSpprtErr = CC[cid].createInstance();
        var crrntDate = rsDBAccess.Execute(SQLId,SQLVer,nSpprtPrmtr,nSpprtErr);
       
        var parser=new DOMParser();
        var resultDoc=parser.parseFromString(crrntDate,"text/xml");
        var currentDate = resultDoc.documentElement.getElementsByTagName('z:row')[0].getAttribute('c0');
        return currentDate;
    }
    catch(e)
    {
        RSAlert('common.js '+' RSFGetNowDate '+ e);
    }
   
}

// Schema：添加字段
function RSSCMAddField1(memoryDS,obj)
{
    var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
    var rdfContainerUtils=Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
    var subject;
    var predicate;
    var target;
    var tableuri;
    var midtarget;
    target=RDF.GetLiteral("true");
    predicate=RDF.GetResource("http://realso.cn/rdf#IsRoot");
    tableuri=memoryDS.GetSource(predicate,target,true);
    
    subject=RDF.GetResource(tableuri.Value+"/"+obj.fieldname);
    predicate=RDF.GetResource("http://realso.cn/rdf#FieldName");
    target=RDF.GetLiteral(obj.fieldname);
    memoryDS.Assert(subject,predicate,target,true);
    
    predicate=RDF.GetResource("http://realso.cn/rdf#IsPrimaryKey");
    target=RDF.GetLiteral(obj.isprimarykey);
    memoryDS.Assert(subject,predicate,target,true);
    
    predicate=RDF.GetResource("http://realso.cn/rdf#NullAble");
    target=RDF.GetLiteral(obj.nullable);
    memoryDS.Assert(subject,predicate,target,true);
    
    predicate=RDF.GetResource("http://realso.cn/rdf#IsIdentity");
    target=RDF.GetLiteral(obj.isidentity);
    memoryDS.Assert(subject,predicate,target,true);
    
    predicate=RDF.GetResource("http://realso.cn/rdf#AllowUpdate");
    target=RDF.GetLiteral(obj.allowupdate);
    memoryDS.Assert(subject,predicate,target,true);
    
    predicate=RDF.GetResource("http://www.w3.org/2000/01/rdf-schema#domain");
    memoryDS.Assert(subject,predicate,tableuri,true);
    
    if(obj.displayname!=null)
    {
    predicate=RDF.GetResource("http://realso.cn/rdf#DisplayName");
    target=RDF.GetLiteral(obj.displayname);
    memoryDS.Assert(subject,predicate,target,true);
    }
    predicate=RDF.GetResource("http://www.w3.org/2000/01/rdf-schema#range");
    target=RDF.GetResource(tableuri.Value+"/"+obj.fieldname+".range");
    memoryDS.Assert(subject,predicate,target,true);
    
    midtarget=RDF.GetResource(tableuri.Value+"/"+obj.fieldname+".range");
    if(obj.datatype=="schema")
    {
      predicate=RDF.GetResource("http://realso.cn/rdf#AutoInst");
      target=RDF.GetLiteral(obj.autoinst);
      memoryDS.Assert(subject,predicate,target,true);
      predicate=RDF.GetResource("http://realso.cn/rdf#IsClass");
      target=RDF.GetResource("http://realso.cn/sqlhouse/"+obj.schemaname);
      memoryDS.Assert(subject,predicate,target,true);
      predicate=RDF.GetResource("http://www.w3.org/2000/01/rdf-schema#subClassOf");
      target=RDF.GetResource("http://realso.cn/sqlhouse/Detailschema");
      memoryDS.Assert(midtarget,predicate,target,true);
            
    }else{
          predicate=RDF.GetResource("http://www.w3.org/2000/01/rdf-schema#subClassOf");
          target=RDF.GetResource("http://www.w3.org/2001/XMLSchema#"+obj.datatype);  
          memoryDS.Assert(midtarget,predicate,target,true);

    }
    
    var container=rdfContainerUtils.MakeSeq(memoryDS,tableuri);    
    container.AppendElement(subject);
    
    

    predicate=RDF.GetResource("http://www.w3.org/2001/XMLSchema#maxLength");
    if(obj.maxlength==null)
    {
      target=RDF.GetLiteral("0");
      memoryDS.Assert(midtarget,predicate,target,true);
    }else{
           target=RDF.GetLiteral(obj.maxlength);
           memoryDS.Assert(midtarget,predicate,target,true);  
    }  
}

/* *******************************************************************************
 * Display the User/Date with the giving ID. Full Username comes from RSSystem,and
 * Current date is from SQL Server Mathine.  
 * *******************************************************************************   
 */
function RSUserDate()
{
   try{
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var xpcomrsSystem= CC["@realso.cn/RSSystem.Service;1"].getService();
        xpcomrsSystem.QueryInterface(CI.nsIRSSystem);
        
        // get current user fullname
        var crrntUsr = xpcomrsSystem.FullName;
        
        // get current date
        var currentDate = RSFGetNowDate();
        
        // UserDate is:
        var UserDate = crrntUsr+' / '+currentDate;
        //RSAlert(UserDate);
        // Display the User/Date
        for(var i=0;i<arguments.length;i++)
        {  
           var disObj = document.getElementById(arguments[i]);
           
           if(null!=disObj)
           {    
                if(('label'==disObj.tagName)||('textbox'==disObj.tagName))
                {
                    disObj.value = UserDate;
                }
                
                var fieldURI = disObj.getAttribute('RS_field');
                var dsPath   = disObj.getAttribute('RS_datasource');
                // RSUpdate
                if(''!=fieldURI)
                {
                    if(null!=document.RSDataSource)
                    {   // If the rdf resource is not exist, I don't know what will happen
                        var retVal =  document.RSDataSource.RSFUpdate(fieldURI, UserDate, dsPath);
                        if(0!=retVal)
                        {
                          // Not successful
                        }
                    }
                }
           }
        }
        return currentDate;
   }catch(e){
       RSAlert('common.js RSUserDate() '+e);
       throw e;
   }
}
function RSFGetCurrentUserID()
{
    try
    {
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var xpcomrsSystem= CC["@realso.cn/RSSystem.Service;1"].getService();
        xpcomrsSystem.QueryInterface(CI.nsIRSSystem);       
        var crrntUsrID = xpcomrsSystem.ID;
        return crrntUsrID;
    }
    catch(e)
    {
        RSAlert(e);
    }

}

// 求当前用户名
function RSFGetCurrentUserName()
{
    try
    {
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var xpcomrsSystem= CC["@realso.cn/RSSystem.Service;1"].getService();
        xpcomrsSystem.QueryInterface(CI.nsIRSSystem);       
        var crrntUsr = xpcomrsSystem.FullName;
        return crrntUsr;
    }
    catch(e)
    {
        alert(e);
    }

}

//检查是否为整数字
function IsNumeric(sText)
{
    try
    {
        var ValidChars = "+-0123456789";
        var IsNumber=true;
        var Char;
        var flag = 1;
        var flag2 = 0;
        var idx;
        for (i = 0; i < sText.length && IsNumber == true; i++) 
        { 
          Char = sText.charAt(i);
          if(Char == '-')
          {
            flag++;
            if(i >0)
                flag++;
            if(i == 0 && sText.length == 1)
                flag++
          }
          if(Char == '+')
          {
            flag ++; 
            if(i >0)
                flag++;
            if(i == 0 && sText.length == 1)
                flag++
          }
          if(Char == '0')
          {
            if(i == 0)
                flag2++;
             if(i>0 && flag2 >0)
                flag2++;

          }
          if (ValidChars.indexOf(Char) == -1) 
          {
             IsNumber = false;
          }
        }
        if(flag > 2 || flag2 >1)
            IsNumber = false;
        return IsNumber;
 
    }
    catch(e)
    {
        RSAlert('运行错误\n位于common.js\nIsFloat()\n"+e');
    }
      
 }
 
 //判断是否是浮点数
 function IsFloat(sText)
 {
    try
    {
       var ValidChars = "+-0123456789.";
       var IsNumber=true;
       var Char;
       var flag = 0;
       if(sText.length == 0)
       {
            IsNumber = false;
            return IsNumber;
       }
       for (i = 0; i < sText.length && IsNumber == true; i++) 
       { 
          Char = sText.charAt(i); 
          if (ValidChars.indexOf(Char) == -1) 
          {
             IsNumber = false;
           }
           if(Char == '.' && i == 0)
           {
             IsNumber = false;
           }
           if(Char == '.')
           {
             flag++;
           }
        }
        if(flag > 1)
        {
           IsNumber = false;
        }
       return IsNumber;
    }
    catch(e)
    {
        RSAlert("运行错误\n位于common.js\nIsFloat()\n"+e);
    }
 }
 
 //检查是否是合法日期
function IsDate(dValue)
{
 try{
     var bRet = false;
     var tempDate = null;
     var year = Number.MIN_VALUE,yearNew; 
     var month = -1,yearNew; 
     var day = -1,yearNew; 
     var timeString = null;
     
     // datetimepicker中的原始正则表达式         
     //var parseNumShortDateRegex = /^\D*(\d+)\D+(\d+)\D+(\d+)(.*)?$/;
     
     // 更改后的正则表达式,只匹配形如 '2000-2-2'的字符串
     var parseNumShortDateRegex = /^(\d+)[-](\d+)[-](\d+)(.*)?$/;
     var dateNumbersArray = parseNumShortDateRegex.exec(dValue);
    
     if (dateNumbersArray != null) 
     {
         year = Number(dateNumbersArray[1]);
         month = Number(dateNumbersArray[2])-1; // 0-based
         day = Number(dateNumbersArray[3]);
         
         // 多余的字符串, 没有才被认为是正确的
         timeString = dateNumbersArray[4];
     }
      
     if((undefined==timeString)&& (year>0 && year<=2050 && month >-1 && day >0) )
     {
         // 由于用户可能输入形如 2003-2-31 的日期(可以自动转为正确的日期2003-3-2),
         // 但是在此不允许用户这样输入. 为此, 先转为正确的日期, 检测是否和输入的
         // 日期相同, 才被认为是正确输入.
         
         var tempDate = new Date(year, month, day, 0, 0, 0, 0);
         
         // -----------------------------------------------
         // CAUTION: If year expire the max year, e.g. 20005, it will throw an exception and 
         // terminate the whole IDE.
         var formattedValue = tempDate.toLocaleFormat("%x");
          
         var dateNumbersArrayNew = parseNumShortDateRegex.exec(formattedValue);
         
         if (dateNumbersArrayNew != null) 
         {
             yearNew = Number(dateNumbersArrayNew[1]);
             monthNew = Number(dateNumbersArrayNew[2])-1; // 0-based
             dayNew = Number(dateNumbersArrayNew[3]);
             timeString = dateNumbersArrayNew[4];
         }
         
         if((yearNew==year)&&(monthNew==month)&&(dayNew==day))
         {
             bRet = true;
         }
     } //else did not match regex, not a valid date
 
     return bRet;
 }catch(e){
    RSAlert("运行错误\n位于common.js\IsDate()\n"+e);
 }
}
/* **************************************************************************************
 * It's a recursion function. Main function of this is set all the childs elements of obj
 * with the given id. The parameters likes function RSFSetAttribute(...) 
 * 成组设置element的属性.设置某个element的所有子element的属性, 并递归.
 * **************************************************************************************
 */
function RSFRecursionSetAttr(attrName, attrValue)
{
  try{
      for(var i=2;i<arguments.length;i++)
      {
        var tempEle = document.getElementById(arguments[i]);
        if(null!=tempEle)
             rcrsnManAttr(tempEle,attrName,attrValue,'set');
      }
  
  }catch(e){
     alert('common.js RSFRecursionSetAttr() '+e);
     throw e;
  }
} 
 
function RSFRecursionRemoveAttr(attrName)
{
  try{
      for(var i=1;i<arguments.length;i++)
      {
        var tempEle = document.getElementById(arguments[i]);
        if(null!=tempEle)
             rcrsnManAttr(tempEle,attrName,'remove');
      }
  
  }catch(e){
     alert('common.js RSFRecursionRemoveAttr() '+e);
     throw e;
  }
} 
 
function rcrsnManAttr(obj, attrName, attrValue, type)
{
  try{
      if(null!=obj)
      {
          if('set'==type)
             obj.setAttribute(attrName, attrValue);
            else
             obj.removeAttribute(attrName); 
              
          if(('menulist'!=obj.tagName) &&
             ('RSmenulist'!=obj.tagName) &&
             ('tree'!=obj.tagName))
          {   
              var m_childs = obj.childNodes;
              for(var i=0;i<m_childs.length;i++)
              {
                rcrsnManAttr(m_childs[i], attrName, attrValue, type);
              }  
          }
      }
  }catch(e){
     alert('common.js rcrsnSetAttr() '+e);
     throw e;
  }   
}

//禁止掉鼠标点击tab页的消息
function DisableTabs(id)
{
 try{
   var tabs=document.getElementById(id)
   tabs.addEventListener("mousedown",StopMsg,true);
   tabs.addEventListener("command",StopMsg,true);
 }catch(e){alert("运行错误\n位于DisableTabs(id)\n"+e);}
}

//取消对tab页消息的禁止
function EnableTabs(id)
{
 try{
   var tabs=document.getElementById(id);
   tabs.removeEventListener("mousedown",StopMsg,true);
   tabs.removeEventListener("command",StopMsg,true);
 }catch(e){alert("运行错误\n位于EnableTabs(id)\n"+e);}
}

function StopMsg(event)
{
  try{
    event.stopPropagation();
  }catch(e){alert("运行错误\n位于stopMsg(event)\n"+e);}
}

//禁止点多表头的tree
function DisableTreeCols(id)
{
    try
    {
        var tabs=document.getElementById(id)
        tabs.addEventListener("mousedown",StopMsg2,true);
        tabs.addEventListener("command",StopMsg2,true);
    }
    catch(e)
    {
        RSAlert("运行错误\n位于DisableTreeCols\n"+e);
    }   
}

function StopMsg2(event)
{
    try
    {
        event.preventDefault();
    }
    catch(e)
    {
        RSAlert("运行错误\n位于stopMsg2(event)\n"+e);
    }
}

//判断数据的合法性，数据类型是否正确，数据长度是否正确，可否为空
function CheckData()
{
    /*
    函数功能：判断数据的合法性，数据类型是否正确，数据长度是否正确，可否为空
    参数介绍：参数数目不限，为元素的ID。
    */
    try
    {
        var strError = '';
        var strString = 'http://www.w3.org/2001/XMLSchema#string';
        var strMaxlen = 'http://www.w3.org/2001/XMLSchema#maxLength';
        var strInt = 'http://www.w3.org/2001/XMLSchema#int';
        var strFloat = 'http://www.w3.org/2001/XMLSchema#float';
        var strLong = 'http://www.w3.org/2001/XMLSchema#long';
        var strShort = 'http://www.w3.org/2001/XMLSchema#short';
        var strByte = 'http://www.w3.org/2001/XMLSchema#byte';
        var strSchema = 'http://realso.cn/sqlhouse/Detailschema';
        var strNulAble = 'http://realso.cn/rdf#NullAble';
        var strIdenty = 'http://realso.cn/rdf#IsIdentity';
        for(var i=0;i<arguments.length;i++)
        {
            var tempEle = document.getElementById(arguments[i]);
            if(null!=tempEle)
            {
                var checkValue = tempEle.value;
                var strFielduri = tempEle.getAttribute('RS_field');
                
                var strFieldName = '';
                //var lastIndex = strFielduri.lastIndexOf('/');
                //求字段名
                //strFieldName = strFielduri.substr(lastIndex+1);  
                strFieldName = GetDisplayName(strFielduri);
                var strType =  document.RSDataSource.RSFGetFieldType(strFielduri);
                if(strType == strInt || strType == strLong || strType == strShort || strType == strLong)
                {
                    var isInt = IsNumeric(checkValue);
                    if(!isInt)
                        strError += strFieldName + '：不是整数\n';
                }
                else if(strType == strFloat)
                {
                    var isFloat = IsFloat(checkValue);
                    if(!isFloat)
                        strError += strFieldName + '：不是小数\n';
                }
                if(strType == strString)
                {
                    var strRange = strFielduri + '.range';
                    var lenValue = document.RSDataSource.GetFieldInfor(strRange,strMaxlen);
                    if(checkValue.length > parseInt(lenValue))
                        strError += strFieldName + '：长度超出了范围\n';
                }
                
                var nullValue = document.RSDataSource.GetFieldInfor(strFielduri,strNulAble);
              
                var identyValue = document.RSDataSource.GetFieldInfor(strFielduri,strIdenty);
          
                if(checkValue.length == 0 && nullValue == 'false' && identyValue == 'false' && strType != strSchema)
                {
                    strError += strFieldName + '：不可以为空\n';
                }
                
            }    
        }
        return strError;
    }
    catch(e)
    {
        RSAlert("运行错误\n位于common.js\nCheckData\n"+e);
    }
}

function GetDisplayName(strFieldUri)
{
    try
    {
        var strDisplayNameUri = 'http://realso.cn/rdf#DisplayName';
         
        var reFieldUri = rdfs.GetResource(strFieldUri);
        var reDisplayUri = rdfs.GetResource(strDisplayNameUri);
         
        var displayName = document.RSDataSource.RsInMemoryDS.GetTarget(reFieldUri,reDisplayUri,true);
        displayName = displayName.QueryInterface(CI.nsIRDFLiteral);
        //alert(displayName.Value);
        if(displayName != null && displayName.Value.length > 0)
            return displayName.Value;
        else
        {
             var lastIndex = strFieldUri.lastIndexOf('/');
                //求字段名
             var strFieldName = strFieldUri.substr(lastIndex+1);  
             return strFieldName;
        }
    }
    catch(e)
    {
        RSAlert("运行错误\n位于common.js\nGetDisplayName()\n"+e);
    }
}
// 消息提示函数
function RSAlert(str)
{
    try{
         var mAlert = window.openDialog("chrome://RealSo/Content/APP/BS/RSAlert.xul","_blank",
                                       "centerscreen,dialog=yes,close,modal=yes,dependent",str);
         return false;                              
    }catch(e){RSAlert("运行错误\n位于common.js\nRSAlert(str)\n"+e);}
}

// 本地化消息提示函数
function RSAlertLocal(str)
{
    try{
        var strbundle=document.getElementById("strings");
        var s=strbundle.getString(str);
        RSAlert(s);
        return false;                              
    }catch(e){alert("Runtime Error\n in common.js\nRSAlert(str)\n"+e);}
}
//str为提示信息，p1为标题,p2,p3为两个按钮的label
function RSConfirm(str,p1,p2,p3)
{
    try{
         
         var obj={flag:null,string:null,caption:null,label1:null,label2:null}
         obj.string=str;
         if(p1!=null)obj.caption=p1;
         if(p2!=null)obj.label1=p2;
         if(p3!=null)obj.label2=p3;
         var mConfirm = window.openDialog("chrome://RealSo/Content/APP/BS/RSConfirm.xul","_blank",
                                       "centerscreen,dialog=yes,close,modal=yes,dependent",obj);
        
         if(obj.flag==0||obj.flag==null)return false;
         else 
            return true;         
    }catch(e){RSAlert("运行错误\n位于common.js\nRSConfirm(str)\n"+e);}
}

// 启动事务
function RSBeginTrans()
{
    /*
    函数功能：启动事务，参数可以传，也可以不传
    */
    try
    {
        var strConnID;
        var sys = CC["@realso.cn/RSSystem.Service;1"].getService(CI.nsIRSSystem);
        var dba  = CC["@realso.cn/XPCOM/RSDBAccess;1"].getService(CI.IRSDBAccess);
        if(arguments.length>0)
        {
          strConnID = arguments[0];
        }
        else
        {
            strConnID = sys.ConnID;
        }
        var ret = dba.BeginTrans(strConnID);
        return ret;
    }
    catch(e)
    {
        
        RSAlert("运行错误\n位于common.js\nRSBeganTrans()\n"+e);
        return 0;
    }
}

/*
    函数功能：提交事务，调用RDFDB的Commit,清理掉修改信息
*/

function RSCommitTrans()
{
    try
    {
       
        var strConnID ;
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var sys = CC["@realso.cn/RSSystem.Service;1"].getService(CI.nsIRSSystem);
        var dba  = CC["@realso.cn/XPCOM/RSDBAccess;1"].getService(CI.IRSDBAccess);
       // var rdfdb = CC["@realso.cn/RSRdfDB;1"].createInstance(CI.nsRSRdfDB);           //这么创建不行，不知道为什么
        var cid = "@realso.cn/RSRdfDB;1";
        //var rdfdb = CC[cid].createInstance();
       // rdfdb = rdfdb.QueryInterface(CI.nsIRSRdfDB);
        if(arguments.length > 0)
        {
          strConnID = arguments[0];
        }
        else
        {   
            strConnID = sys.ConnID;
           
        }
        var ret = dba.CommitTrans(strConnID);
        if(ret == 1)
            document.RSDataSource.Commit();
        return ret;
    }
    catch(e)
    {
       
        RSAlert("运行错误\n位于common.js\RSCommitTrans()\n"+e);
        return 0;
    }
}

/*
    函数功能：事务回滚
*/
function RSRollbackTrans()
{
    try
    {
        var sys = CC["@realso.cn/RSSystem.Service;1"].getService(CI.nsIRSSystem);
        var dba  = CC["@realso.cn/XPCOM/RSDBAccess;1"].getService(CI.IRSDBAccess);
        var strConnID ;
        if(arguments.length > 0)
        {
          strConnID = arguments[0];
        }
        else
        {
            strConnID = sys.ConnID;
        }
        var ret = dba.RollbackTrans(strConnID);
        return ret;
    }
    catch(e)
    {
       
        RSAlert("运行错误\n位于common.js\RSRollbackTrans()\n"+e);
        return 0;
    }
}

// Only for using Modal dialog with RSmenulist
function RSopenDialog(fileName,title,config,paras)
{
 try{
  window.openDialog("chrome://RealSo/content/APP/SS/RSMLModal.xul","Modal",
  "menubar=no,location=no,resizable=no,scrollbars=no,titlebar=no,status=no,dependent=yes,modal=yes", window.frameElement.parentNode.ownerDocument,fileName,title,config,paras);
 }catch(e){
    RSAlert("运行错误\n位于common.js\RSopenDialog()\n"+e);
}
}

/*
    函数功能：保存单据号时调用
*/
function RSsaveBillNum(isNew,oldBillNum,newBillNum,billTypeCode,billID,billDate,createBillDate,subTypeCode)
{
    try
    {
        var sys = GetSys();
        var dba  = GetDBA();
        var AccountID = sys.AccountNo;
        var UserID = sys.ID;
        //1.检查是否存在重弃号，如果存在，则弹出重弃号列表
        var par = RSFCreateParameters(createBillDate,billTypeCode,subTypeCode,AccountID,UserID,billID,newBillNum);
        //检查有没有重弃号
        var ret = dba.HasSameOrDesertedNum(par);
        //从返回值中分离出是否有重弃号标志，变号控制符，合并类型编码
        var HasSame = ret.substr(0,1);
        var HasDisc = ret.substr(1,1);
        var lastindex = ret.lastIndexOf('#');
        var ContrlChar = ret.substring(3,lastindex);
        var IncorporatID = ret.substring(lastindex+1,ret.length);
        var DiscardID = '';
        //取判断进入的条件
        par = RSFCreateParameters(billTypeCode,HasSame,HasDisc);
        var permission = dba.CheckPermission(par);
        if(permission == 3)
        {
            //存在重弃号，则列出
            var retVals = {ok: false,isNew:isNew,oldBillNum:oldBillNum,newBillNum:newBillNum,BillID:billID,discardID:DiscardID,billTypeCode:billTypeCode,ControlChar:ContrlChar
                       ,subTypeCode:subTypeCode};
            window.openDialog('SameOrDiscard.xul','重号弃号列表','modal=yes,centerscreen=yes',retVals);
            //调保存函数
            if(retVals.ok == true)
            {
                var old = retVals.oldBillNum;
                var newN = retVals.newBillNum;
                var isnew = retVals.isNew;
                var discid = retVals.discardID;
                var newID = dba.NewID();
                var creatByID = sys.ID;
                var username = sys.Name;
                par = RSFCreateParameters(isnew,discid,newID,old,newN,creatByID,username,createBillDate,ContrlChar,billTypeCode,billID,billDate);
                dba.SaveBillNum(par);
            }
            else
            {   //返回就直接保存
                var newID = dba.NewID();
                var creatByID = sys.ID;
                var username = sys.Name;
                par = RSFCreateParameters(isNew,DiscardID,newID,oldBillNum,newBillNum,creatByID,username,createBillDate,ContrlChar,billTypeCode,billID,billDate);
                dba.SaveBillNum(par);
            }
            
        }
        else if(permission == 2)
        {
            RSAlert('单据号禁止重号、现存在重号，不能保存');
            return 0;
        }
        else if(permission == 1)
        {
            //调保存函数
            var creatByID = sys.ID;
            var username = sys.Name;
            var newID = dba.NewID();
            par = RSFCreateParameters(isNew,DiscardID,newID,oldBillNum,newBillNum,creatByID,username,createBillDate,ContrlChar,billTypeCode,billID,billDate);
            dba.SaveBillNum(par);
        }
        //2.如果存在重弃号，则根据用户在界面的操作，对相应的参数做修改
        //3.执行保存
    }
    catch(e)
    {
        RSAlert("运行错误\n位于common.js\nRSsaveBillNum()\n"+e);
    }
}
/*
  从RDF-Seq中读一个Item，返回nsIRDFNode
  输入：数据源，Seq的主语，要找的Item序号（从1开始）
*/
function GetSeqItem(ds,sub,i)
{
    var seqIndex="http://www.w3.org/1999/02/22-rdf-syntax-ns#_"+i;
    var preSeq=rdfs.GetResource(seqIndex);
    return ds.GetTarget(sub,preSeq,true);
}

/*
  求DBAccess服务
  返回：nsIRSDBAccess接口
*/
function GetDBA()
{
    var dba = CC["@realso.cn/XPCOM/RSDBAccess;1"].getService(CI.IRSDBAccess);
    
    return dba;
}

/*
  求System服务
  返回：nsIRSSystem接口
*/
function GetSys()
{
    var sys = CC["@realso.cn/RSSystem.Service;1"].getService(CI.nsIRSSystem);
    
    return sys;
}

/*
    函数功能：取单据号
    参数说明：1.单据类型ID，2.单据子类型编码，如果没有子类型，传空，3.单据日期
*/
function GetBillCode(BillDate,BillTypeCode,SubBillCode)
{
    try
    {
        var sys = GetSys();
        var AccountID = sys.AccountNo;
        var UserID = sys.ID;
        var par = RSFCreateParameters(BillDate,BillTypeCode,SubBillCode,AccountID,UserID,'');
        var dba = GetDBA();
        var BillCode = dba.GetBillCode(par);
        return BillCode;
    }
    catch(e)
    {
        RSAlert("运行错误\n位于common.js\nGetBillCode()\n"+e);
    }
}
/*
检查单据日期的合法性，返回:最小日期@最大日期。需要调用者从返回值中分离出最大最小日期
*/
function CheckBillDate(BillDate,BillTypeCode)
{
    try
    {
        var sys = GetSys();
        var AccountID = sys.AccountNo;
        var par = RSFCreateParameters(BillDate,BillTypeCode,AccountID);
        var dba = GetDBA();
        var retDate = dba.CheckBillDate(par);
        return retDate;
    }
    catch(e)
    {
        RSAlert("运行错误\n位于common.js\nGetBillCode()\n"+e);
    }
}